//
//  AFLSettingAPI.m
//  airbridge_flutter_sdk
//
//  Created by WOF on 15/10/2019.
//

#import "AFLSettingAPI.h"

#import "AirbridgeFL.h"

// AB
#import "ABGet.h"

@implementation AFLSettingAPI

//
// flutter plugin setting
//

+ (void) registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel* channel = [FlutterMethodChannel methodChannelWithName:@"airbridge_flutter_sdk/method/setting"
                                                                binaryMessenger:registrar.messenger];
    AFLSettingAPI* instance = [[AFLSettingAPI alloc] init];
    
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void) handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    NSDictionary* arguments = [ABGet type:NSDictionary.class object:call.arguments];
    
    if ([@"setSessionTimeout" isEqualToString:call.method]) {
        [self setSessionTimeout:arguments result:result];
    } else if ([@"setDeeplinkFetchTimeout" isEqualToString:call.method]) {
        [self setDeeplinkFetchTimeout:arguments result:result];
    } else if ([@"setIsUserInfoHashed" isEqualToString:call.method]) {
        [self setIsUserInfoHashed:arguments result:result];
    } else if ([@"setIsTrackAirbridgeDeeplinkOnly" isEqualToString:call.method]) {
        [self setIsTrackAirbridgeDeeplinkOnly:arguments result:result];
    } else if ([@"setIsTrackingEnabled" isEqualToString:call.method]) {
        [self setIsTrackingEnabled:arguments result:result];
    } else {
        result(FlutterMethodNotImplemented);
    }
}

//
// flutter method
//

- (void) setSessionTimeout:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSNumber* timeout = [ABGet type:NSNumber.class dictionary:arguments key:@"timeout"];
    
    [AirbridgeFL setSessionTimeout:timeout.integerValue];
    
    result(nil);
}

- (void) setDeeplinkFetchTimeout:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSNumber* timeout = [ABGet type:NSNumber.class dictionary:arguments key:@"timeout"];

    [AirbridgeFL setDeeplinkFetchTimeout:timeout.integerValue];

    result(nil);
}

- (void) setIsUserInfoHashed:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSNumber* enable = [ABGet type:NSNumber.class dictionary:arguments key:@"enable"];
    
    [AirbridgeFL setIsUserInfoHashed:enable.boolValue];
    
    result(nil);
}

- (void) setIsTrackAirbridgeDeeplinkOnly:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSNumber* enable = [ABGet type:NSNumber.class dictionary:arguments key:@"enable"];
    
    [AirbridgeFL setIsTrackAirbridgeDeeplinkOnly:enable.boolValue];
    
    result(nil);
}

- (void) setIsTrackingEnabled:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSNumber* enable = [ABGet type:NSNumber.class dictionary:arguments key:@"enable"];
    
    [AirbridgeFL setIsTrackingEnabled:enable.boolValue];
    
    result(nil);
}

@end
