//
//  AFLStateAPI.m
//  airbridge_flutter_sdk
//
//  Created by WOF on 08/10/2019.
//

#import "AFLStateAPI.h"

// Airbridge
#import "AirBridge.h"
// AB
#import "ABGet.h"

NS_ASSUME_NONNULL_BEGIN

@implementation AFLStateAPI

//
// flutter plugin setting
//

+ (void) registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    FlutterMethodChannel* channel = [FlutterMethodChannel methodChannelWithName:@"airbridge_flutter_sdk/method/state"
                                                                binaryMessenger:registrar.messenger];
    AFLStateAPI* instance = [[AFLStateAPI alloc] init];
    
    [registrar addMethodCallDelegate:instance channel:channel];
}

- (void) handleMethodCall:(FlutterMethodCall*)call result:(FlutterResult)result {
    NSDictionary* arguments = [ABGet type:NSDictionary.class object:call.arguments];
    
    if ([@"setUser" isEqualToString:call.method]) {
        [self setUser:arguments result:result];
    } else if ([@"updateUser" isEqualToString:call.method]) {
        [self updateUser:arguments result:result];
    } else if ([@"getDeviceUUID" isEqualToString:call.method]) {
        [self getDeviceUUID:result];
    } else if ([@"getIsLimitADTracking" isEqualToString:call.method]) {
        [self getIsLimitADTracking:result];
    } else {
        result(FlutterMethodNotImplemented);
    }
}

//
// flutter method
//

- (void) setUser:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSString* ID = [ABGet type:NSString.class dictionary:arguments key:@"id"];
    NSString* email = [ABGet type:NSString.class dictionary:arguments key:@"email"];
    NSString* phone = [ABGet type:NSString.class dictionary:arguments key:@"phone"];
    
    [AirBridge.state setUserID:ID];
    [AirBridge.state setUserEmail:email];
    [AirBridge.state setUserPhone:phone];
    
    result(nil);
}

- (void) updateUser:(nullable NSDictionary*)arguments result:(FlutterResult)result {
    NSString* ID = [ABGet type:NSString.class dictionary:arguments key:@"id"];
    NSString* email = [ABGet type:NSString.class dictionary:arguments key:@"email"];
    NSString* phone = [ABGet type:NSString.class dictionary:arguments key:@"phone"];
    
    if (!ID) {
        [AirBridge.state setUserID:ID];
    }
    if (!email) {
        [AirBridge.state setUserEmail:email];
    }
    if (!phone) {
        [AirBridge.state setUserPhone:phone];
    }
    
    result(nil);
}

- (void) getDeviceUUID:(FlutterResult)result {
    result(AirBridge.deviceUUID);
}

- (void) getIsLimitADTracking:(FlutterResult)result {
    result(@(AirBridge.isLimitADTracking));
}

@end

NS_ASSUME_NONNULL_END
