#import "AirbridgeFL.h"

#import "AFLDeeplinkAPI.h"
#import "AFLEventAPI.h"
#import "AFLStateAPI.h"
#import "AFLSettingAPI.h"
#import "AFLPlacementAPI.h"

// Airbridge
#import <AirBridge/AirBridge.h>
#import <AirBridge/ABDeeplink.h>

@implementation AirbridgeFL

static AirbridgeFL* instance;

//
// flutter plugin setting
//

+ (void) registerWithRegistrar:(NSObject<FlutterPluginRegistrar>*)registrar {
    [AFLDeeplinkAPI registerWithRegistrar:registrar];
    [AFLEventAPI registerWithRegistrar:registrar];
    [AFLStateAPI registerWithRegistrar:registrar];
    [AFLSettingAPI registerWithRegistrar:registrar];
    [AFLPlacementAPI registerWithRegistrar:registrar];
}

//
// init
//

+ (nullable AirbridgeFL*)instance {
    return instance;
}

+ (AirbridgeFL*) getInstance:(NSString *)appToken
                     appName:(NSString *)appName
           withLaunchOptions:(NSDictionary *)launchOptions
{
    [AirBridge getInstance:appToken appName:appName withLaunchOptions:launchOptions];
    [AFLDeeplinkAPI setInitialDeeplinkCallback];
    
    if (instance != nil) {
        instance = [[AirbridgeFL alloc] init];
    }
    
    return instance;
}

//
// interface
//

+ (ABState*)state {
    return AirBridge.state;
}

+ (ABDeeplink*)deeplink {
    return AirBridge.deeplink;
}

//
// setting
//

+ (void)setSessionTimeout:(NSInteger)millisecond {
    [AirBridge setSessionTimeout:millisecond];
}

+ (void)setDeeplinkFetchTimeout:(NSInteger)millisecond {
    [AirBridge.deeplink setHandleTrackingLinkTimeout:millisecond];
}

+ (void)setIsUserInfoHashed:(BOOL)enable {
    [AirBridge setIsUserInfoHashed:enable];
}

+ (void)setIsTrackAirbridgeDeeplinkOnly:(BOOL)enable {
    [AirBridge setIsTrackAirbridgeDeeplinkOnly:enable];
}

+ (void)setIsTrackingEnabled:(BOOL)enable {
    [AirBridge setIsLimitTracking:!enable];
}

@end
