import 'package:airbridge_flutter_sdk/data/event_option.dart';
import 'package:airbridge_flutter_sdk/data/product.dart';
import 'package:airbridge_flutter_sdk/event/event.dart';

class AddToCartEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.product.addedToCart';

    String cartID;
    List<Product> products;
    String currency;
    num total;

    AddToCartEvent({this.cartID,
                    this.products,
                    this.currency,
                    this.total,
                    EventOption option})
        : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        return {
            'category': category,
            'option': option?.toMap(),
            'cartID': cartID,
            'products': products?.map((product) => product.toMap())?.toList(),
            'currency': currency,
            'total': total,
        };
    }
}