import 'package:airbridge_flutter_sdk/data/event_option.dart';
import 'package:airbridge_flutter_sdk/data/product.dart';
import 'package:airbridge_flutter_sdk/event/event.dart';

class ViewProductDetailEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.product.viewed';

    List<Product> products;

    ViewProductDetailEvent({this.products,
                            EventOption option})
        : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        return {
            'category': category,
            'option': option?.toMap(),
            'products': products?.map((product) => product.toMap())?.toList()
        };
    }
}