import 'package:airbridge_flutter_sdk/data/product.dart';
import 'package:airbridge_flutter_sdk/data/event_option.dart';
import 'package:airbridge_flutter_sdk/event/event.dart';

class ViewProductListEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.productList.viewed';

    String listID;
    List<Product> products;

    ViewProductListEvent({this.listID,
        this.products,
        EventOption option})
        : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        return {
            'category': category,
            'option': option?.toMap(),
            'listID': listID,
            'products': products?.map((product) => product.toMap())?.toList()
        };
    }
}