import 'package:airbridge_flutter_sdk/data/product.dart';
import 'package:airbridge_flutter_sdk/data/event_option.dart';
import 'package:airbridge_flutter_sdk/event/event.dart';

class ViewSearchResultEvent extends Event {
    static const String CATEGORY = 'airbridge.ecommerce.searchResults.viewed';

    String query;
    List<Product> products;

    ViewSearchResultEvent({this.query,
                            this.products,
                            EventOption option})
        : super(CATEGORY, option: option);

    @override
    Map<String, dynamic> toMap() {
        return {
            'category': category,
            'option': option?.toMap(),
            'query': query,
            'products': products?.map((product) => product.toMap())?.toList()
        };
    }
}