import 'package:airbridge_flutter_sdk/util/log.dart';
import 'package:flutter/services.dart';

class SettingAPI {
    final MethodChannel _method;

    SettingAPI(this._method);

    void setSessionTimeout(int timeout) {
        Log.info('setSessionTimeout $timeout');

        _method.invokeMethod('setSessionTimeout', {
            'timeout': timeout
        });
    }

    void setDeeplinkFetchTimeout(int timeout) {
        Log.info('setDeeplinkFetchTimeout $timeout');

        _method.invokeMethod('setDeeplinkFetchTimeout', {
            'timeout': timeout
        });
    }

    void setIsUserInfoHashed(bool enable) {
        Log.info('setIsUserInfoHashed $enable');

        _method.invokeMethod('setIsUserInfoHashed', {
            'enable': enable
        });
    }

    void setIsTrackingEnabled(bool enable) {
        Log.info('setIsTrackingEnabled $enable');

        _method.invokeMethod('setIsTrackingEnabled', {
            'enable': enable
        });
    }
}
